#pragma once

#include "ClockCtrl.h"


class CMainFrame : public CFrameWnd
{
public:
//Constructors / Destructors
  CMainFrame() noexcept;
  CMainFrame(const CMainFrame&) = delete;
  CMainFrame(CMainFrame&&) = delete;
  ~CMainFrame() = default; //NOLINT(modernize-use-override)

//Methods
  CMainFrame& operator=(const CMainFrame&) = delete;
  CMainFrame& operator=(CMainFrame&&) = delete;

protected:
//Member variables
  bool m_bTopMostWindow;
  CMenu m_MainMenu;
  CClockCtrl m_ctrlClock;

//Methods
  BOOL PreCreateWindow(CREATESTRUCT& cs) override;
  BOOL OnCreateClient(LPCREATESTRUCT lpcs, CCreateContext* pContext) override;

//Message handlers
  afx_msg void OnContextMenu(CWnd*, CPoint point);
  afx_msg void OnFileTransparent();
  afx_msg void OnUpdateFileTransparent(CCmdUI* pCmdUI);
  afx_msg void OnFileAlwaysontop();
  afx_msg void OnUpdateFileAlwaysontop(CCmdUI* pCmdUI);
  afx_msg void OnFileCaption();
  afx_msg void OnUpdateFileCaption(CCmdUI* pCmdUI);
  afx_msg void OnSize(UINT nType, int cx, int cy);
  afx_msg void OnLButtonDblClk(UINT nFlags, CPoint point);
  afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
  afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);

  DECLARE_MESSAGE_MAP()

  DECLARE_DYNCREATE(CMainFrame)
};
